package org.jfree.date.test;

import static org.junit.Assert.assertEquals;

import org.jfree.date.Month;
import org.jfree.date.SerialDate;
import org.jfree.date.SpreadsheetDate;
import org.junit.Test;

public class TestDateExamples {
	
	@Test
	public void testValidDate() {
		// Example test
		SerialDate date1 = new SpreadsheetDate(15,Month.MAY,2009);
		assertEquals(15, date1.getDayOfMonth());
		assertEquals(Month.MAY, date1.getMonth());
		assertEquals(2009, date1.getYYYY());
	}

	@Test
	public void testFirstValidDate() {
		// Example test
		SerialDate date1 = new SpreadsheetDate(01,Month.JANUARY,1900);
		assertEquals(01, date1.getDayOfMonth());
		assertEquals(Month.JANUARY, date1.getMonth());
		assertEquals(1900, date1.getYYYY());
	}
	
	@Test(expected=IllegalArgumentException.class)
	public void testInvalidDayDate() {
		// Example test
		new SpreadsheetDate(40,Month.MAY,2009);
	}

	@Test(expected=IllegalArgumentException.class)
	public void testInvalidLeapDayDate() {
		// Example test
		new SpreadsheetDate(29,Month.FEBRUARY,2009);
	}

	@Test(expected=IllegalArgumentException.class)
	public void testInvalid100YearLeapDayDate() {
		// Example test
		new SpreadsheetDate(29,Month.FEBRUARY,1900);
	}

	
	@Test
	public void testValidLeapDayDate() {
		// Example test
		SerialDate date1 = new SpreadsheetDate(29,Month.FEBRUARY,2008);
		assertEquals(29, date1.getDayOfMonth());
		assertEquals(Month.FEBRUARY, date1.getMonth());
		assertEquals(2008, date1.getYYYY());
	}
	
	@Test
	public void testValid400YearLeapDayDate() {
		// Example test
		SerialDate date1 = new SpreadsheetDate(29,Month.FEBRUARY,2000);
		assertEquals(29, date1.getDayOfMonth());
		assertEquals(Month.FEBRUARY, date1.getMonth());
		assertEquals(2000, date1.getYYYY());
	}
	
}
